Index: squid/src/store_client.c
diff -u squid/src/store_client.c:1.7 squid/src/store_client.c:1.2.2.13
--- squid/src/store_client.c:1.7	Sat Mar  3 02:44:32 2001
+++ squid/src/store_client.c	Sun Mar 18 14:33:32 2001
@@ -40,13 +40,11 @@
  *       'Body' refers to the swapfile body, which is the full
  *        HTTP reply (including HTTP headers and body).
  */
+#if 0
 static STRCB storeClientReadBody;
 static STRCB storeClientReadHeader;
-static void storeClientCopy2(StoreEntry * e, store_client * sc);
-static void storeClientCopy3(StoreEntry * e, store_client * sc);
 static void storeClientFileRead(store_client * sc);
-static EVH storeClientCopyEvent;
-static store_client_t storeClientType(StoreEntry *);
+#endif
 static int CheckQuickAbort2(StoreEntry * entry);
 static void CheckQuickAbort(StoreEntry * entry);
 
@@ -55,278 +53,92 @@
 int
 storeClientWaiting(const StoreEntry * e)
 {
-    MemObject *mem = e->mem_obj;
-    dlink_node *node;
-    store_client *sc;
-    for (node = mem->clients.head; node; node = node->next) {
-	sc = node->data;
-	if (sc->callback_data != NULL)
+    if (e->sc.callback_data != NULL)
 	    return 1;
-    }
     return 0;
 }
 
-#if STORE_CLIENT_LIST_DEBUG
-store_client *
-storeClientListSearch(const MemObject * mem, void *data)
-{
-    dlink_node *node;
-    store_client *sc = NULL;
-    for (node = mem->clients.head; node; node = node->next) {
-	sc = node->data;
-	if (sc->callback_data == data)
-	    return sc;
-    }
-    return NULL;
-}
-#endif
-
-static store_client_t
-storeClientType(StoreEntry * e)
-{
-    MemObject *mem = e->mem_obj;
-    if (mem->inmem_lo)
-	return STORE_DISK_CLIENT;
-    if (EBIT_TEST(e->flags, ENTRY_ABORTED)) {
-	/* I don't think we should be adding clients to aborted entries */
-	debug(20, 1) ("storeClientType: adding to ENTRY_ABORTED entry\n");
-	return STORE_MEM_CLIENT;
-    }
-    if (e->store_status == STORE_OK) {
-	if (mem->inmem_lo == 0 && mem->inmem_hi > 0)
-	    return STORE_MEM_CLIENT;
-	else
-	    return STORE_DISK_CLIENT;
-    }
-    /* here and past, entry is STORE_PENDING */
-    /*
-     * If this is the first client, let it be the mem client
-     */
-    else if (mem->nclients == 1)
-	return STORE_MEM_CLIENT;
-    /*
-     * If there is no disk file to open yet, we must make this a
-     * mem client.  If we can't open the swapin file before writing
-     * to the client, there is no guarantee that we will be able
-     * to open it later when we really need it.
-     */
-    else if (e->swap_status == SWAPOUT_NONE)
-	return STORE_MEM_CLIENT;
-    /*
-     * otherwise, make subsequent clients read from disk so they
-     * can not delay the first, and vice-versa.
-     */
-    else
-	return STORE_DISK_CLIENT;
-}
 
 /* add client with fd to client list */
-store_client *
-storeClientListAdd(StoreEntry * e, void *data)
+void
+storeClientRegister(StoreEntry * e, void *data)
 {
-    MemObject *mem = e->mem_obj;
-    store_client *sc;
-    assert(mem);
-#if STORE_CLIENT_LIST_DEBUG
-    if (storeClientListSearch(mem, data) != NULL)
-	assert(1 == 0);		/* XXX die! */
-#endif
     e->refcount++;
-    mem->nclients++;
-    sc = cbdataAlloc(store_client);
-    cbdataLock(data);		/* locked while we point to it */
-    sc->callback_data = data;
-    sc->seen_offset = 0;
-    sc->copy_offset = 0;
-    sc->flags.disk_io_pending = 0;
-    sc->entry = e;
-    sc->type = storeClientType(e);
-    if (sc->type == STORE_DISK_CLIENT)
-	/* assert we'll be able to get the data we want */
-	/* maybe we should open swapin_fd here */
-	assert(e->swap_filen > -1 || storeSwapOutAble(e));
-    dlinkAdd(sc, &sc->node, &mem->clients);
+
+    assert(e->sc.valid == 0);
+    e->sc.valid = 1;
+    e->sc.callback_data = data;
+    e->sc.seen_offset = 0;
+    e->sc.copy_offset = 0;
+    e->sc.flags.disk_io_pending = 0;
+    e->sc.entry = e;
+
+    /* Lock the data that we're using .. */
+    cbdataLock(data);
 #if DELAY_POOLS
-    sc->delay_id = 0;
+    e->sc.delay_id = 0;
 #endif
-    return sc;
 }
 
 static void
-storeClientCallback(store_client * sc, ssize_t sz)
+storeClientCallback(StoreEntry *e, ssize_t sz)
 {
-    STCB *callback = sc->callback;
-    char *buf = sc->copy_buf;
-    assert(sc->callback);
-    sc->callback = NULL;
-    sc->copy_buf = NULL;
-    if (cbdataValid(sc->callback_data))
-	callback(sc->callback_data, buf, sz);
-}
-
-static void
-storeClientCopyEvent(void *data)
-{
-    store_client *sc = data;
-    debug(20, 3) ("storeClientCopyEvent: Running\n");
-    sc->flags.copy_event_pending = 0;
-    if (!sc->callback)
-	return;
-    storeClientCopy2(sc->entry, sc);
+    STCB *callback = e->sc.callback;
+    char *buf = e->sc.copy_buf;
+    assert(e->sc.valid == 1);
+    assert(e->sc.callback);
+    e->sc.callback = NULL;
+    e->sc.copy_buf = NULL;
+    if (cbdataValid(e->sc.callback_data))
+	callback(e->sc.callback_data, buf, sz);
 }
 
 /* copy bytes requested by the client */
 void
-storeClientCopy(store_client * sc,
-    StoreEntry * e,
+storeClientCopy(StoreEntry * e,
     off_t seen_offset,
     off_t copy_offset,
     size_t size,
     char *buf,
     STCB * callback,
     void *data)
-{
+{   
+    store_client *sc = &e->sc;
     assert(!EBIT_TEST(e->flags, ENTRY_ABORTED));
-    debug(20, 3) ("storeClientCopy: %s, seen %d, want %d, size %d, cb %p, cbdata %p\n",
-	storeKeyText(e->hash.key),
-	(int) seen_offset,
-	(int) copy_offset,
-	(int) size,
-	callback,
-	data);
-    assert(sc != NULL);
-#if STORE_CLIENT_LIST_DEBUG
-    assert(sc == storeClientListSearch(e->mem_obj, data));
-#endif
+
+    assert(!EBIT_TEST(e->flags, ENTRY_ABORTED));
+    assert(sc->valid == 1);
+    debug(20, 3) ("storeClientCopy: %s, seen %d, want %d, size %d, cb %p, cbdata %p\n", storeKeyUrl(e),
+        (int) seen_offset,
+        (int) copy_offset,
+        (int) size,
+        callback,
+        data);
+
     assert(sc->callback == NULL);
     assert(sc->entry == e);
+    assert(sc->copy_offset == sc->seen_offset); /* Just until everything has been changed */
     sc->copy_offset = copy_offset;
     sc->seen_offset = seen_offset;
     sc->callback = callback;
     sc->copy_buf = buf;
     sc->copy_size = size;
     sc->copy_offset = copy_offset;
-    storeClientCopy2(e, sc);
-}
 
-/*
- * This function is used below to decide if we have any more data to
- * send to the client.  If the store_status is STORE_PENDING, then we
- * do have more data to send.  If its STORE_OK, then
- * we continue checking.  If the object length is negative, then we
- * don't know the real length and must open the swap file to find out.
- * If the length is >= 0, then we compare it to the requested copy
- * offset.
- */
-static int
-storeClientNoMoreToSend(StoreEntry * e, store_client * sc)
-{
-    ssize_t len;
-    if (e->store_status == STORE_PENDING)
-	return 0;
-    if ((len = objectLen(e)) < 0)
-	return 0;
-    if (sc->copy_offset < len)
-	return 0;
-    return 1;
+    e->stclientcopy(e);
 }
 
-static void
-storeClientCopy2(StoreEntry * e, store_client * sc)
-{
-    if (sc->flags.copy_event_pending)
-	return;
-    if (EBIT_TEST(e->flags, ENTRY_FWD_HDR_WAIT)) {
-	debug(20, 5) ("storeClientCopy2: returning because ENTRY_FWD_HDR_WAIT set\n");
-	return;
-    }
-    if (sc->flags.store_copying) {
-	sc->flags.copy_event_pending = 1;
-	debug(20, 3) ("storeClientCopy2: Queueing storeClientCopyEvent()\n");
-	eventAdd("storeClientCopyEvent", storeClientCopyEvent, sc, 0.0, 0);
-	return;
-    }
-    cbdataLock(sc);		/* ick, prevent sc from getting freed */
-    sc->flags.store_copying = 1;
-    debug(20, 3) ("storeClientCopy2: %s\n", storeKeyText(e->hash.key));
-    assert(sc->callback != NULL);
-    /*
-     * We used to check for ENTRY_ABORTED here.  But there were some
-     * problems.  For example, we might have a slow client (or two) and
-     * the server-side is reading far ahead and swapping to disk.  Even
-     * if the server-side aborts, we want to give the client(s)
-     * everything we got before the abort condition occurred.
-     */
-    storeClientCopy3(e, sc);
-    sc->flags.store_copying = 0;
-    cbdataUnlock(sc);		/* ick, allow sc to be freed */
-}
 
-static void
-storeClientCopy3(StoreEntry * e, store_client * sc)
+int
+storeClientCopyPending(StoreEntry * e, void *data)
 {
-    MemObject *mem = e->mem_obj;
-    size_t sz;
-
-    if (storeClientNoMoreToSend(e, sc)) {
-	/* There is no more to send! */
-	storeClientCallback(sc, 0);
-	return;
-    }
-    if (e->store_status == STORE_PENDING && sc->seen_offset >= mem->inmem_hi) {
-	/* client has already seen this, wait for more */
-	debug(20, 3) ("storeClientCopy3: Waiting for more\n");
-	return;
-    }
-    /*
-     * Slight weirdness here.  We open a swapin file for any
-     * STORE_DISK_CLIENT, even if we can copy the requested chunk
-     * from memory in the next block.  We must try to open the
-     * swapin file before sending any data to the client side.  If
-     * we postpone the open, and then can not open the file later
-     * on, the client loses big time.  Its transfer just gets cut
-     * off.  Better to open it early (while the client side handler
-     * is clientCacheHit) so that we can fall back to a cache miss
-     * if needed.
-     */
-    if (STORE_DISK_CLIENT == sc->type && NULL == sc->swapin_sio) {
-	debug(20, 3) ("storeClientCopy3: Need to open swap in file\n");
-	/* gotta open the swapin file */
-	if (storeTooManyDiskFilesOpen()) {
-	    /* yuck -- this causes a TCP_SWAPFAIL_MISS on the client side */
-	    storeClientCallback(sc, -1);
-	    return;
-	} else if (!sc->flags.disk_io_pending) {
-	    /* Don't set store_io_pending here */
-	    storeSwapInStart(sc);
-	    if (NULL == sc->swapin_sio) {
-		storeClientCallback(sc, -1);
-		return;
-	    }
-	    /*
-	     * If the open succeeds we either copy from memory, or
-	     * schedule a disk read in the next block.
-	     */
-	} else {
-	    debug(20, 1) ("WARNING: Averted multiple fd operation (1)\n");
-	    return;
-	}
-    }
-    if (sc->copy_offset >= mem->inmem_lo && sc->copy_offset < mem->inmem_hi) {
-	/* What the client wants is in memory */
-	debug(20, 3) ("storeClientCopy3: Copying from memory\n");
-	sz = stmemCopy(&mem->data_hdr,
-	    sc->copy_offset, sc->copy_buf, sc->copy_size);
-	storeClientCallback(sc, sz);
-	return;
-    }
-    /* What the client wants is not in memory. Schedule a disk read */
-    assert(STORE_DISK_CLIENT == sc->type);
-    assert(!sc->flags.disk_io_pending);
-    debug(20, 3) ("storeClientCopy3: reading from STORE\n");
-    storeClientFileRead(sc);
+    if (e->sc.callback == NULL)
+        return 0;
+    return 1;
 }
 
+
+#if 0
 static void
 storeClientFileRead(store_client * sc)
 {
@@ -343,7 +155,9 @@
 	    sc);
     } else {
 	if (sc->entry->swap_status == SWAPOUT_WRITING)
+#if 0
 	    assert(storeOffset(mem->swapout.sio) > sc->copy_offset + mem->swap_hdr_sz);
+#endif
 	storeRead(sc->swapin_sio,
 	    sc->copy_buf,
 	    sc->copy_size,
@@ -471,129 +285,68 @@
     storeClientFileRead(sc);
 }
 
-int
-storeClientCopyPending(store_client * sc, StoreEntry * e, void *data)
-{
-#if STORE_CLIENT_LIST_DEBUG
-    assert(sc == storeClientListSearch(e->mem_obj, data));
 #endif
-    assert(sc->entry == e);
-    if (sc == NULL)
-	return 0;
-    if (sc->callback == NULL)
-	return 0;
-    return 1;
-}
+
 
 /*
- * This routine hasn't been optimised to take advantage of the
- * passed sc. Yet.
+ * Disassociate a client from a storeentry
  */
 int
-storeUnregister(store_client * sc, StoreEntry * e, void *data)
+storeClientUnregister(StoreEntry * e, void *data)
 {
+    store_client *sc = &e->sc;
     MemObject *mem = e->mem_obj;
-#if STORE_CLIENT_LIST_DEBUG
-    assert(sc == storeClientListSearch(e->mem_obj, data));
-#endif
-    if (mem == NULL)
-	return 0;
-    debug(20, 3) ("storeUnregister: called for '%s'\n", storeKeyText(e->hash.key));
+
+    debug(20, 3) ("storeUnregister: called for '%s'\n", storeKeyUrl(e));
+
     if (sc == NULL)
 	return 0;
-    if (mem->clients.head == NULL)
-	return 0;
-    if (sc == mem->clients.head->data) {
-	/*
-	 * If we are unregistering the _first_ client for this
-	 * entry, then we have to reset the client FD to -1.
-	 */
-	mem->fd = -1;
-    }
-    dlinkDelete(&sc->node, &mem->clients);
-    mem->nclients--;
-    if (e->store_status == STORE_OK && e->swap_status != SWAPOUT_DONE)
-	storeSwapOut(e);
-    if (sc->swapin_sio) {
-	storeClose(sc->swapin_sio);
-	cbdataUnlock(sc->swapin_sio);
-	sc->swapin_sio = NULL;
-	statCounter.swap.ins++;
-    }
+
+    assert(sc == &e->sc);
+    assert(mem != NULL);
+    assert(e->sc.valid == 1);
+
+    mem->fd = -1;
+
     if (NULL != sc->callback) {
 	/* callback with ssize = -1 to indicate unexpected termination */
 	debug(20, 3) ("storeUnregister: store_client for %s has a callback\n",
 	    mem->url);
-	storeClientCallback(sc, -1);
+	storeClientCallback(e, -1);
     }
 #if DELAY_POOLS
     delayUnregisterDelayIdPtr(&sc->delay_id);
 #endif
+    e->sc.valid = 0;
     cbdataUnlock(sc->callback_data);	/* we're done with it now */
-    /*assert(!sc->flags.disk_io_pending); */
-    cbdataFree(sc);
     assert(e->lock_count > 0);
-    if (mem->nclients == 0)
-	CheckQuickAbort(e);
+    CheckQuickAbort(e);
     return 1;
 }
 
+
+/* .. and this routine becomes meaningless.. :) */
 off_t
 storeLowestMemReaderOffset(const StoreEntry * entry)
 {
-    const MemObject *mem = entry->mem_obj;
-    off_t lowest = mem->inmem_hi + 1;
-    store_client *sc;
-    dlink_node *nx = NULL;
-    dlink_node *node;
-
-    for (node = mem->clients.head; node; node = nx) {
-	sc = node->data;
-	nx = node->next;
-	if (sc->callback_data == NULL)	/* open slot */
-	    continue;
-	if (sc->type != STORE_MEM_CLIENT)
-	    continue;
-	if (sc->type == STORE_DISK_CLIENT)
-	    if (NULL != sc->swapin_sio)
-		continue;
-	if (sc->copy_offset < lowest)
-	    lowest = sc->copy_offset;
-    }
-    return lowest;
+    return entry->sc.copy_offset;
 }
 
 /* Call handlers waiting for  data to be appended to E. */
 void
 InvokeHandlers(StoreEntry * e)
 {
-    int i = 0;
-    MemObject *mem = e->mem_obj;
-    store_client *sc;
-    dlink_node *nx = NULL;
-    dlink_node *node;
-
-    debug(20, 3) ("InvokeHandlers: %s\n", storeKeyText(e->hash.key));
-    /* walk the entire list looking for valid callbacks */
-    for (node = mem->clients.head; node; node = nx) {
-	sc = node->data;
-	nx = node->next;
-	debug(20, 3) ("InvokeHandlers: checking client #%d\n", i++);
-	if (sc->callback_data == NULL)
-	    continue;
-	if (sc->callback == NULL)
-	    continue;
-	if (sc->flags.disk_io_pending)
-	    continue;
-	storeClientCopy2(e, sc);
-    }
+    assert(e->mem_obj != NULL);
+    debug(20, 3) ("InvokeHandlers: %s\n", storeKeyUrl(e));
+    e->stflush(e);
 }
 
 int
 storePendingNClients(const StoreEntry * e)
 {
-    MemObject *mem = e->mem_obj;
-    int npend = NULL == mem ? 0 : mem->nclients;
+    int npend = 0;
+    if (e->sc.valid)
+        npend = 1;
     debug(20, 3) ("storePendingNClients: returning %d\n", npend);
     return npend;
 }
@@ -617,7 +370,7 @@
 	return 1;
     }
     expectlen = mem->reply->content_length + mem->reply->hdr_sz;
-    curlen = (int) mem->inmem_hi;
+    curlen = (int) storeMemHiOffset(entry);
     minlen = (int) Config.quickAbort.min << 10;
     if (minlen < 0) {
 	debug(20, 3) ("CheckQuickAbort2: NO disabled\n");
Index: squid/src/store_digest.c
diff -u squid/src/store_digest.c:1.9 squid/src/store_digest.c:1.2.2.7
--- squid/src/store_digest.c:1.9	Sat Mar  3 02:44:32 2001
+++ squid/src/store_digest.c	Sun Mar 18 14:33:32 2001
@@ -350,10 +350,14 @@
     url = internalLocalUri("/squid-internal-periodic/", StoreDigestFileName);
     flags = null_request_flags;
     flags.cachable = 1;
-    e = storeCreateEntry(url, url, flags, METHOD_GET);
+    sd_state.rewrite_lock = CBDATA_ALLOC(generic_cbdata, NULL);
     assert(e);
     sd_state.rewrite_lock = cbdataAlloc(generic_cbdata);
     sd_state.rewrite_lock->data = e;
+    e = storeCreateEntry(url, url, flags, METHOD_GET,
+      REPLY_OBJ_NETWORK);
+    assert(sd_state.rewrite_lock);
+    cbdataAdd(sd_state.rewrite_lock, NULL, 0);
     debug(71, 3) ("storeDigestRewrite: url: %s key: %s\n", url, storeKeyText(e->hash.key));
     e->mem_obj->request = requestLink(urlParse(METHOD_GET, url));
     /* wait for rebuild (if any) to finish */
Index: squid/src/store_dir.c
diff -u squid/src/store_dir.c:1.14 squid/src/store_dir.c:1.2.2.7
--- squid/src/store_dir.c:1.14	Tue Mar 13 14:49:49 2001
+++ squid/src/store_dir.c	Sun Mar 18 14:33:32 2001
@@ -197,6 +197,7 @@
 	    continue;
 	if (load > least_load)
 	    continue;
+	/* Only use leastsize if the load is equal */
 	cur_free = SD->max_size - SD->cur_size;
 	/* If the load is equal, then look in more details */
 	if (load == least_load) {
@@ -252,7 +253,7 @@
     assert(op > SWAP_LOG_NOP && op < SWAP_LOG_MAX);
     debug(20, 3) ("storeDirSwapLog: %s %s %d %08X\n",
 	swap_log_op_str[op],
-	storeKeyText(e->hash.key),
+	storeKeyUrl(e),
 	e->swap_dirn,
 	e->swap_filen);
     sd = &Config.cacheSwap.swapDirs[e->swap_dirn];
@@ -371,11 +372,11 @@
     SwapDir *sd;
     int dirn;
     int notdone = 1;
-    if (store_dirs_rebuilding) {
-	debug(20, 1) ("Not currently OK to rewrite swap log.\n");
-	debug(20, 1) ("storeDirWriteCleanLogs: Operation aborted.\n");
-	return 0;
-    }
+    /*
+     * We used to check here whether we were rebuilding the store dirs.
+     * If we were, we didn't attempt to write clean logs. Now, we let the
+     * filesystems decide that for themselves in sd->log.clean.start().
+     */
     debug(20, 1) ("storeDirWriteCleanLogs: Starting...\n");
     getCurrentTime();
     start = current_time;
Index: squid/src/store_io.c
diff -u squid/src/store_io.c:1.2 squid/src/store_io.c:1.2.2.2
--- squid/src/store_io.c:1.2	Sat Oct 21 08:16:13 2000
+++ squid/src/store_io.c	Tue Feb  6 02:08:04 2001
@@ -18,7 +18,8 @@
  * to select different polices depending on object size or type.
  */
 storeIOState *
-storeCreate(StoreEntry * e, STIOCB * file_callback, STIOCB * close_callback, void *callback_data)
+storeCreate(StoreEntry * e, STIOCB * file_callback, STIOCB * close_callback,
+  void *callback_data)
 {
     size_t objsize;
     sdirno dirn;
@@ -29,7 +30,7 @@
     /* This is just done for logging purposes */
     objsize = objectLen(e);
     if (objsize != -1)
-	objsize += e->mem_obj->swap_hdr_sz;
+       objsize += e->mem_obj->swap_hdr_sz;
 
     /*
      * Pick the swapdir
@@ -37,32 +38,65 @@
      */
     dirn = storeDirSelectSwapDir(e);
     if (dirn == -1) {
-	debug(20, 2) ("storeCreate: no valid swapdirs for this object\n");
-	store_io_stats.create.select_fail++;
-	return NULL;
+       debug(20, 2) ("storeCreate: no valid swapdirs for this object\n");
+       store_io_stats.create.select_fail++;
+       return NULL;
     }
-    debug(20, 2) ("storeCreate: Selected dir '%d' for obj size '%d'\n", dirn, objsize);
+    debug(20, 2) ("storeCreate: Selected dir '%d' for obj size '%d'\n", dirn,
+      objsize);
     SD = &Config.cacheSwap.swapDirs[dirn];
 
     /* Now that we have a fs to use, call its storeCreate function */
     sio = SD->obj.create(SD, e, file_callback, close_callback, callback_data);
     if (NULL == sio)
-	store_io_stats.create.create_fail++;
+       store_io_stats.create.create_fail++;
     else
-	store_io_stats.create.success++;
+       store_io_stats.create.success++;
     return sio;
 }
 
 
+
+/*
+ * storeLookup - the eventual replacement for storeGet()/storeGetPublic()
+ * 
+ * This function handles issuing lookups to each of the object stores.
+ * A callback/data pair will be called with the StoreEntry referencing
+ * the object if one is found, or NULL is returned.
+ *
+ * Yes, its inefficient right now, but there isn't much we can do about
+ * it until we've got *something* that works..
+ */
+void
+storeLookup(request_t *request, STGETDONE *callback, void *callback_data)
+{
+    /* Only begin a lookup in StoreDir 0 for now */
+    SwapDir *sd = INDEXSD(0);
+
+    /* Lock the request and callback */
+    cbdataLock(request);
+    cbdataLock(callback_data);
+
+    sd->obj.get(sd, request, callback, callback_data);
+}
+
 /*
- * storeOpen() is purely for reading ..
+ * storeLookupComplete - called at the completion (sucess/failure!) of
+ * a given lookup.
+ *
+ * This function unlocks the request and then issues the callback.
  */
-storeIOState *
-storeOpen(StoreEntry * e, STFNCB * file_callback, STIOCB * callback,
-    void *callback_data)
+void
+storeLookupComplete(request_t *request, STGETDONE *callback,
+    void *callback_data, StoreEntry *e)
 {
-    SwapDir *SD = &Config.cacheSwap.swapDirs[e->swap_dirn];
-    return SD->obj.open(SD, e, file_callback, callback, callback_data);
+    /* Only callback if the request_t and the callback are valid! */
+    if (cbdataValid(request) && cbdataValid(callback_data))
+        callback(callback_data, e);
+
+    /* Unlock, which can possibly free these two entries now */
+    cbdataUnlock(request);
+    cbdataUnlock(callback_data);
 }
 
 void
Index: squid/src/store_log.c
diff -u squid/src/store_log.c:1.6 squid/src/store_log.c:1.2.2.5
--- squid/src/store_log.c:1.6	Sat Feb 17 12:56:22 2001
+++ squid/src/store_log.c	Tue Feb 20 07:39:42 2001
@@ -75,14 +75,14 @@
 	    storeLogTags[tag],
 	    e->swap_dirn,
 	    e->swap_filen,
-	    storeKeyText(e->hash.key),
+	    storeKeyUrl(e),
 	    reply->sline.status,
 	    (int) reply->date,
 	    (int) reply->last_modified,
 	    (int) reply->expires,
 	    strLen(reply->content_type) ? strBuf(reply->content_type) : "unknown",
 	    reply->content_length,
-	    (int) (mem->inmem_hi - mem->reply->hdr_sz),
+	    (int) (storeMemHiOffset(e) - mem->reply->hdr_sz),
 	    RequestMethodStr[mem->method],
 	    mem->log_url);
     } else {
@@ -93,7 +93,7 @@
 	    storeLogTags[tag],
 	    e->swap_dirn,
 	    e->swap_filen,
-	    storeKeyText(e->hash.key));
+	    storeKeyUrl(e));
     }
 }
 
Index: squid/src/store_rebuild.c
diff -u squid/src/store_rebuild.c:1.7 squid/src/store_rebuild.c:1.2.2.6
--- squid/src/store_rebuild.c:1.7	Fri Jan 12 00:20:33 2001
+++ squid/src/store_rebuild.c	Fri Jan 12 00:46:08 2001
@@ -37,7 +37,6 @@
 
 static struct _store_rebuild_data counts;
 static struct timeval rebuild_start;
-static void storeCleanup(void *);
 
 typedef struct {
     /* total number of "swap.state" entries that will be read */
@@ -55,58 +54,6 @@
     return (SD->dblcheck(SD, e));
 }
 
-static void
-storeCleanup(void *datanotused)
-{
-    static int bucketnum = -1;
-    static int validnum = 0;
-    static int store_errors = 0;
-    int validnum_start;
-    StoreEntry *e;
-    hash_link *link_ptr = NULL;
-    hash_link *link_next = NULL;
-    validnum_start = validnum;
-    while (validnum - validnum_start < 500) {
-	if (++bucketnum >= store_hash_buckets) {
-	    debug(20, 1) ("  Completed Validation Procedure\n");
-	    debug(20, 1) ("  Validated %d Entries\n", validnum);
-	    debug(20, 1) ("  store_swap_size = %dk\n", store_swap_size);
-	    store_dirs_rebuilding--;
-	    assert(0 == store_dirs_rebuilding);
-	    if (opt_store_doublecheck)
-		assert(store_errors == 0);
-	    if (store_digest)
-		storeDigestNoteStoreReady();
-	    return;
-	}
-	link_next = hash_get_bucket(store_table, bucketnum);
-	while (NULL != (link_ptr = link_next)) {
-	    link_next = link_ptr->next;
-	    e = (StoreEntry *) link_ptr;
-	    if (EBIT_TEST(e->flags, ENTRY_VALIDATED))
-		continue;
-	    /*
-	     * Calling storeRelease() has no effect because we're
-	     * still in 'store_rebuilding' state
-	     */
-	    if (e->swap_filen < 0)
-		continue;
-	    if (opt_store_doublecheck)
-		if (storeCleanupDoubleCheck(e))
-		    store_errors++;
-	    EBIT_SET(e->flags, ENTRY_VALIDATED);
-	    /*
-	     * Only set the file bit if we know its a valid entry
-	     * otherwise, set it in the validation procedure
-	     */
-	    storeDirUpdateSwapSize(&Config.cacheSwap.swapDirs[e->swap_dirn], e->swap_file_sz, 1);
-	    if ((++validnum & 0x3FFFF) == 0)
-		debug(20, 1) ("  %7d Entries Validated so far.\n", validnum);
-	}
-    }
-    eventAdd("storeCleanup", storeCleanup, NULL, 0.0, 1);
-}
-
 /* meta data recreated from disk image in swap directory */
 void
 storeRebuildComplete(struct _store_rebuild_data *dc)
@@ -122,6 +69,8 @@
     counts.badflags += dc->badflags;
     counts.bad_log_op += dc->bad_log_op;
     counts.zero_object_sz += dc->zero_object_sz;
+    store_dirs_rebuilding--;
+
     /*
      * When store_dirs_rebuilding == 1, it means we are done reading
      * or scanning all cache_dirs.  Now report the stats and start
@@ -141,9 +90,8 @@
     debug(20, 1) ("  %7d Swapfile clashes avoided.\n", counts.clashcount);
     debug(20, 1) ("  Took %3.1f seconds (%6.1f objects/sec).\n", dt,
 	(double) counts.objcount / (dt > 0.0 ? dt : 1.0));
-    debug(20, 1) ("Beginning Validation Procedure\n");
-    eventAdd("storeCleanup", storeCleanup, NULL, 0.0, 1);
     xfree(RebuildProgress);
+    store_dirs_rebuilding = 0;
     RebuildProgress = NULL;
 }
 
Index: squid/src/store_swapin.c
diff -u squid/src/store_swapin.c:1.5 squid/src/store_swapin.c:1.2.2.3
--- squid/src/store_swapin.c:1.5	Fri Jan 12 00:20:33 2001
+++ squid/src/store_swapin.c	Fri Jan 12 00:46:08 2001
@@ -38,6 +38,7 @@
 static STIOCB storeSwapInFileClosed;
 static STFNCB storeSwapInFileNotify;
 
+#if 0
 void
 storeSwapInStart(store_client * sc)
 {
@@ -94,3 +95,4 @@
     e->swap_filen = sio->swap_filen;
     e->swap_dirn = sio->swap_dirn;
 }
+#endif
Index: squid/src/store_swapout.c
diff -u squid/src/store_swapout.c:1.7 squid/src/store_swapout.c:1.2.2.6
--- squid/src/store_swapout.c:1.7	Sat Mar  3 02:44:32 2001
+++ squid/src/store_swapout.c	Sun Mar 18 14:33:32 2001
@@ -40,6 +40,12 @@
 static STIOCB storeSwapOutFileClosed;
 static STIOCB storeSwapOutFileNotify;
 
+
+
+#if 0
+
+
+
 /* start swapping object to disk */
 static void
 storeSwapOutStart(StoreEntry * e)
@@ -115,16 +121,16 @@
 	storeSwapOutFileClose(e);
 	return;
     }
-    debug(20, 7) ("storeSwapOut: mem->inmem_lo = %d\n",
-	(int) mem->inmem_lo);
-    debug(20, 7) ("storeSwapOut: mem->inmem_hi = %d\n",
-	(int) mem->inmem_hi);
+    debug(20, 7) ("storeSwapOut: storeMemLoOffset = %d\n",
+	(int) storeMemLoOffset(e));
+    debug(20, 7) ("storeSwapOut: storeMemHiOffset = %d\n",
+	(int) storeMemHiOffset(e));
     debug(20, 7) ("storeSwapOut: swapout.queue_offset = %d\n",
 	(int) mem->swapout.queue_offset);
     if (mem->swapout.sio)
 	debug(20, 7) ("storeSwapOut: storeOffset() = %d\n",
 	    (int) storeOffset(mem->swapout.sio));
-    assert(mem->inmem_hi >= mem->swapout.queue_offset);
+    assert(storeMemHiOffset(e) >= mem->swapout.queue_offset);
     lowest_offset = storeLowestMemReaderOffset(e);
     debug(20, 7) ("storeSwapOut: lowest_offset = %d\n",
 	(int) lowest_offset);
@@ -132,22 +138,22 @@
      * Grab the swapout_size and check to see whether we're going to defer
      * the swapout based upon size
      */
-    swapout_size = (ssize_t) (mem->inmem_hi - mem->swapout.queue_offset);
+    swapout_size = (ssize_t) (storeMemHiOffset(e) - mem->swapout.queue_offset);
     if ((e->store_status != STORE_OK) && (swapout_size < store_maxobjsize)) {
 	debug(20, 5) ("storeSwapOut: Deferring starting swapping out\n");
 	return;
     }
     /*
-     * Careful.  lowest_offset can be greater than inmem_hi, such
+     * Careful.  lowest_offset can be greater than storeMemHiOffset, such
      * as in the case of a range request.
      */
-    if (mem->inmem_hi < lowest_offset)
+    if (storeMemHiOffset(e) < lowest_offset)
 	new_mem_lo = lowest_offset;
-    else if (mem->inmem_hi - lowest_offset > Config.Store.maxInMemObjSize)
+    else if (storeMemHiOffset(e) - lowest_offset > Config.Store.maxInMemObjSize)
 	new_mem_lo = lowest_offset;
     else
-	new_mem_lo = mem->inmem_lo;
-    assert(new_mem_lo >= mem->inmem_lo);
+	new_mem_lo = storeMemLoOffset(e);
+    assert(new_mem_lo >= storeMemLoOffset(e));
     if (storeSwapOutAble(e)) {
 	/*
 	 * We should only free up to what we know has been written
@@ -172,7 +178,7 @@
     stmemFreeDataUpto(&mem->data_hdr, new_mem_lo);
     mem->inmem_lo = new_mem_lo;
     if (e->swap_status == SWAPOUT_WRITING)
-	assert(mem->inmem_lo <= on_disk);
+	assert(storeMemLoOffset(e) <= on_disk);
     if (!storeSwapOutAble(e))
 	return;
     debug(20, 7) ("storeSwapOut: swapout_size = %d\n",
@@ -196,7 +202,7 @@
     /* Ok, we have stuff to swap out.  Is there a swapout.sio open? */
     if (e->swap_status == SWAPOUT_NONE) {
 	assert(mem->swapout.sio == NULL);
-	assert(mem->inmem_lo == 0);
+	assert(storeMemLoOffset(e) == 0);
 	if (storeCheckCachable(e))
 	    storeSwapOutStart(e);
 	else
@@ -239,7 +245,7 @@
 	/* the storeWrite() call might generate an error */
 	if (e->swap_status != SWAPOUT_WRITING)
 	    break;
-	swapout_size = (ssize_t) (mem->inmem_hi - mem->swapout.queue_offset);
+	swapout_size = (ssize_t) (storeMemHiOffset(e) - mem->swapout.queue_offset);
 	if (e->store_status == STORE_PENDING)
 	    if (swapout_size < SM_PAGE_SIZE)
 		break;
@@ -253,7 +259,7 @@
 	 * to the filesystem at this point because storeSwapOut() is
 	 * not going to be called again for this entry.
 	 */
-	assert(mem->inmem_hi == mem->swapout.queue_offset);
+	assert(storeMemHiOffset(e) == mem->swapout.queue_offset);
 	storeSwapOutFileClose(e);
     }
 }
@@ -346,7 +352,7 @@
     dlink_node *node;
     if (e->mem_obj->swapout.sio != NULL)
 	return 1;
-    if (e->mem_obj->inmem_lo > 0)
+    if (storeMemLoOffset(e) > 0)
 	return 0;
     /*
      * If there are DISK clients, we must write to disk
@@ -361,3 +367,7 @@
 	    return 0;
     return EBIT_TEST(e->flags, ENTRY_CACHABLE);
 }
+
+
+
+#endif
